; #####################################################################################################
; # Screensaver Preview Window Demo with Flurry Saver by Eikon
; # Version 1.1
; # Requires B+
; # You can include this in any saver, commercial or otherwise, for free.
; # I do ask that you humbly give me a mention in your code, readme, etc. ;)
; #####################################################################################################
; # You'll need these userlib entries to compile. 
; # Refer to your blitz/userlibs/userlibs.txt file for help.
; # 
; # .lib "kernel32.dll"
; # CreateMutex%(lpMutexAttributes%,bInitialOwner%,lpName$):"CreateMutexA" 
; # GetLastError%()
; #
; # .lib "user32.dll"
; # FindWindow%(class$, Text$) : "FindWindowA"
; #
; # The main functions have been placed in sub.bb to keep this file clean. Use this as 
; # a framework for adding a preview window to your own savers.
; #####################################################################################################
Include "sub.bb"

; #####################################################################################################
; # The preview window constantly monitors this file which tells it when to unload.
; # This keeps only one copy of your saver.scr open. Direct where it goes with file_path$ below.
; #####################################################################################################
ChangeDir SystemProperty("appdir")
Global file_path$ = SystemProperty("systemdir") + "vb_pre.bin"    ; Path of our status file (required)

; Images for Flurry
gfx_path$ = SystemProperty("systemdir") + "flurry_gfx/"           ; Change this to where your
Global Back = LoadImage(gfx_Path$ + "back.bmp")                   ; images are located.
Global Snowman = LoadImage(gfx_Path$ + "snowman.bmp"): MaskImage Snowman, 255, 0, 255
Global Tree1 = LoadImage(gfx_Path$ + "tree1.bmp")
Global Tree2 = LoadImage(gfx_Path$ + "tree2.bmp")
Global Flake = LoadAnimImage(gfx_Path$ + "flake.bmp", 23, 23, 0, 2)
MidHandle Flake

; #####################################################################################################
; # L O C K   F I L E   S E T U P
; # If you do change the file_path$ then uncomment this code below for your first execution to
; # create the status file and set it properly. Be sure to comment it back because if this gets in your
; # exe you'll open mutiple copies and fill memory fast.
; #####################################################################################################
;File = WriteFile(file_path$)
;WriteByte File, 0
;CloseFile File

; #####################################################################################################
; # Below is the standard code for handling the command line parameters being passed to us 
; # by Windows. These tell us what to do when the user changes the saver or presses a button.
; # Heres a break down of what each means:
; #
; #      /p hWnd   User made a saver selection, closed the config form, or clicked 'Apply'.   
; #                The handle its passing us is the preview window we are trying to access.
; #                vb_pre.exe actually finds the window so we dont need to worry about it here.
; #
; #      /c        This is when we load the Configuration window with the Configure() function.
; #
; #      /s        Here you run your actual screensaver code.
; #
; #####################################################################################################
Select Left(CommandLine$(), 2)
	Case "/p": Preview()   ; Preview
    Case "/c": Config()    ; Configure
	Case "/s": Run()       ; Run                 

End Select
End

; #####################################################################################################
; # Screen Saver Preview Window 
; # 
; # This is the basic code needed for vb_pre and bb_pre to get along successfully. Do all your
; # preview canvas work in sub.bb's Render_Preview(). I advise you to leave this function untouched.
; #####################################################################################################
Function Preview()
hwnd = CreateMutex(0, 1, "bb_mutex") ; Check for multiple instances of our saver with a mutex
                                     ; thanks soja :)
If GetLastError() = 183 Then         ; We are already running
	File = WriteFile(file_path$)     ; Tell previous instance to unload
	WriteByte File, 1
	CloseFile File
	Repeat                           ; Wait for old instance to unload before continuing
		File = ReadFile(file_path$) 
		tmp = ReadByte(File)
		CloseFile File
	Until tmp = 0
EndIf

; Create Preview Window (Do NOT change window title, dont worry, you dont see it.)
Parent = CreateWindow("bb_pre", ClientWidth(Desktop()) + 1, 0, 152, 112, 0, 16)
Canvas = CreateCanvas(0, 0, 152, 112, Parent) ; Do not change any dimensions
SetBuffer CanvasBuffer(Canvas)

ExecFile "vb_pre.exe" ; Execute vb_pre (Visual Basic program that does the work)

scroll$ = "Blitz+ Preview Window Access"
X = 152

AutoSuspend 1
CreateTimer(60)       ; 60 FPS
File = ReadFile(file_path$) ; Dont Change
Repeat

Select WaitEvent()
	Case $4001        ; Tick
	Cls
	
	tmp = 0
	For i = 0 To 112 Step 2
		Color 0, 0, tmp: Rect 0, i, 152, 2, 1
		tmp = tmp + 5
		If tmp >= 255 Then tmp = 255
	Next

	Color 255, 255, 255: Text X, 57, Scroll$
	X = X - 2
 	If X < -(Len(scroll$) * 12) Then X = 152

	SeekFile File, 0
	tmp = ReadByte(File)             
	Ret = FindWindow("#32770", "Display Properties") ; Window class doesnt seem to change,
                                                     ; hasnt been tested on win 95
	If tmp = 1 Or Ret = 0 Then       ; Unload
		CloseFile File
		File = WriteFile(file_path$) ; Reset
		WriteByte File, 0
		CloseFile File
		FreeGadget Parent
		End                          ; Go to your Unload() function here. (Free images, sfx, etc.)
	EndIf
	
	VWait 1: FlipCanvas Canvas, 1

End Select
Forever

End Function


; #####################################################################################################
; # Configuration Window (Create your config GUI here)
; #####################################################################################################
Function Config()
CParent = CreateWindow("Flurry Settings (template for your own window)", ClientWidth(Desktop())/2-200, ClientHeight(Desktop())/2-150, 400, 300, 0, 1)
btn_Ok = CreateButton("OK", 296, 250, 96, 24, CParent, 1)

Repeat
Select WaitEvent()
	Case $803
	End

	Case $401
	Select EventSource()
		Case btn_Ok
		FreeGadget CParent
		End

	End Select

End Select
Forever

End Function